import { NgModule, enableProdMode, ErrorHandler } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';
import { FormsModule } from '@angular/forms';
import { HttpModule } from '@angular/http';

import { EJ_GRID_COMPONENTS } from './ej/grid.component';
import {EJ_BUTTON_COMPONENTS } from './ej/button.component';
import { EJTemplateDirective } from './ej/template';

import { EJ_Grid_InlineFormTemplate } from './gridtemplates/ej.grid.inlineformtemplate';
import { EJ_Grid_DetailTemplate } from './gridtemplates/ej.grid.detail-template';
import { EJ_Grid_RowTemplate } from './gridtemplates/ej.grid.rowtemplate';
import { EJ_Grid_SummaryTemplate } from './gridtemplates/ej.grid.summarytemplate';
import { EJ_Grid_GroupcaptionTemplate } from './gridtemplates/ej.grid.groupingtemplate';
import { AppComponent } from './app.component';
import { HomeComponent } from './home/home.component';
import { GridComponent } from './grid/grid.component';

import { RowTemplateComponent } from './rowtemplate/rowtemplate.component';
import { SummaryTemplateComponent } from './summarytemplate/summarytemplate.component';
import { GroupCaptionComponent } from './groupcaption/groupcaption.component';
import { EditTemplateComponent } from './edittemplates/edit.component';
import { rootRouterConfig } from './app.routes';

enableProdMode();

class CustomErrorHandler implements ErrorHandler {
  call(error, stackTrace = null, reason = null) {
    console.log(error + "\n" + stackTrace);
  }
  handleError(error: any): void {
    console.log(error);
  }
}

@NgModule({
  imports: [BrowserModule, FormsModule, HttpModule, RouterModule.forRoot(rootRouterConfig, { useHash: true })],
  declarations: [EJ_GRID_COMPONENTS,EJ_BUTTON_COMPONENTS,
   EJ_Grid_DetailTemplate, EJTemplateDirective, EJ_Grid_InlineFormTemplate,EJ_Grid_SummaryTemplate,EJ_Grid_GroupcaptionTemplate,
   EJ_Grid_RowTemplate, RowTemplateComponent,SummaryTemplateComponent, GroupCaptionComponent,EditTemplateComponent,
    AppComponent, HomeComponent, GridComponent],
  bootstrap: [AppComponent]
})
export class AppModule { }